//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern bool UseOSMA              = true;
extern int  OSMAFastPeriod       = 12;
extern int  OSMASlowPeriod       = 26;
extern int  OSMASignalPeriod     = 9;
extern int  OSMAPrice            = PRICE_CLOSE;
extern bool UseEldersImpulse     = true;
extern int  EimpEmaPeriod        = 13;
extern int  EimpMacdFastPeriod   = 12;
extern int  EimpMacdSlowPeriod   = 26;
extern int  EimpMacdSignalPeriod =  9;
extern int  EimpPrice            = PRICE_CLOSE;

//
//
//
//
//

double valueUp[];
double valueDn[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,valueUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,valueDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][10];
#define _osmaFast  0
#define _osmaSlow  1
#define _osmaSign  2
#define _osmaOsma  3
#define _osmaTren  4
#define _eimpema   5
#define _eimpmacdv 6
#define _eimpmacds 7
#define _eimpmacdo 8
#define _eimpTren  9


int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

      double osmaAFast = 2.0 / (1.0 + OSMAFastPeriod);
      double osmaASlow = 2.0 / (1.0 + OSMASlowPeriod);
      double osmaASign = 2.0 / (1.0 + OSMASignalPeriod);
      double eimpAlpha = 2.0 / (1.0 + EimpMacdSignalPeriod);

      
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         double price = iMA(NULL,0,1,0,MODE_SMA,OSMAPrice,i);
         if (r==0)
         {
            work[r][_osmaFast] = price;
            work[r][_osmaSlow] = price;
            work[r][_osmaSign] = price;
            continue;
         }

         //
         //
         //
         //
         //
           
         double result = 0;
         double max    = 0;

         if (UseOSMA)
         {
            max++;
            work[r][_osmaFast] = work[r-1][_osmaFast]+osmaAFast*(price-work[r-1][_osmaFast]);
            work[r][_osmaSlow] = work[r-1][_osmaSlow]+osmaASlow*(price-work[r-1][_osmaSlow]);
                   double macd = work[r][_osmaFast]-work[r][_osmaSlow];
            work[r][_osmaSign] = work[r-1][_osmaSign]+osmaASign*(macd -work[r-1][_osmaSign]);
            work[r][_osmaOsma] = macd-work[r][_osmaSign];
            work[r][_osmaTren] = 0;
                  if (work[r][_osmaOsma]>work[r-1][_osmaOsma] && work[r][_osmaOsma]>0) work[r][_osmaTren]= 1;
                  if (work[r][_osmaOsma]<work[r-1][_osmaOsma] && work[r][_osmaOsma]<0) work[r][_osmaTren]=-1;
                     result += work[r][_osmaTren];
         }
         if (UseEldersImpulse)
         {
            max++;
            work[r][_eimpema]   = iMA(NULL,0,EimpEmaPeriod,0,MODE_EMA,EimpPrice,i); 
            work[r][_eimpmacdv] = iMA(NULL,0,EimpMacdFastPeriod,0,MODE_EMA,EimpPrice,i)-iMA(NULL,0,EimpMacdSlowPeriod,0,MODE_EMA,EimpPrice,i);
            work[r][_eimpmacds] = work[r-1][_eimpmacds]+eimpAlpha*(work[r][_eimpmacdv]-work[r-1][_eimpmacds]);
            work[r][_eimpmacdo] = work[r][_eimpmacdv]-work[r][_eimpmacds];
            work[r][_eimpTren]  = 0;
               double cOpen  = Open[i];
               double cClose = Close[i];
            if (work[r][_eimpema]<work[r-1][_eimpema] && work[r][_eimpmacdo]<work[r-1][_eimpmacdo]) work[r][_eimpTren] = -1;
            if (work[r][_eimpema]>work[r-1][_eimpema] && work[r][_eimpmacdo]>work[r-1][_eimpmacdo]) work[r][_eimpTren] =  1;
                     result += work[r][_eimpTren];
         }         
         
         //
         //
         //
         //
         //

        valueUp[i] = EMPTY_VALUE;         
        valueDn[i] = EMPTY_VALUE;         
           if (result== max) valueUp[i] = 1;
           if (result==-max) valueDn[i] = 1;
      }
   return(0);
}

